{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [],
   "source": [
    "from __future__ import print_function\n",
    "from ortools.graph import pywrapgraph"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [],
   "source": [
    "import networkx as nx"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 623,
   "metadata": {},
   "outputs": [],
   "source": [
    "import seaborn as sns\n",
    "import matplotlib as mplt\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "%matplotlib inline\n",
    "\n",
    "pd.set_option('display.max_rows', 1000)\n",
    "pd.set_option('display.max_columns', 500)\n",
    "pd.set_option('display.width', 1000)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 573,
   "metadata": {},
   "outputs": [],
   "source": [
    "def strftime(epoch_v):\n",
    "    return time.strftime(\"%Y-%m-%d %H:%M:%S %Z\", time.localtime(float(epoch_v)))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 706,
   "metadata": {},
   "outputs": [],
   "source": [
    "from shapely.geometry import Point\n",
    "from shapely.geometry.polygon import Polygon\n",
    "import geopandas"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 712,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "\n",
       "    <div class=\"bk-root\">\n",
       "        <a href=\"https://bokeh.pydata.org\" target=\"_blank\" class=\"bk-logo bk-logo-small bk-logo-notebook\"></a>\n",
       "        <span id=\"1001\">Loading BokehJS ...</span>\n",
       "    </div>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "(function(root) {\n",
       "  function now() {\n",
       "    return new Date();\n",
       "  }\n",
       "\n",
       "  var force = true;\n",
       "\n",
       "  if (typeof (root._bokeh_onload_callbacks) === \"undefined\" || force === true) {\n",
       "    root._bokeh_onload_callbacks = [];\n",
       "    root._bokeh_is_loading = undefined;\n",
       "  }\n",
       "\n",
       "  var JS_MIME_TYPE = 'application/javascript';\n",
       "  var HTML_MIME_TYPE = 'text/html';\n",
       "  var EXEC_MIME_TYPE = 'application/vnd.bokehjs_exec.v0+json';\n",
       "  var CLASS_NAME = 'output_bokeh rendered_html';\n",
       "\n",
       "  /**\n",
       "   * Render data to the DOM node\n",
       "   */\n",
       "  function render(props, node) {\n",
       "    var script = document.createElement(\"script\");\n",
       "    node.appendChild(script);\n",
       "  }\n",
       "\n",
       "  /**\n",
       "   * Handle when an output is cleared or removed\n",
       "   */\n",
       "  function handleClearOutput(event, handle) {\n",
       "    var cell = handle.cell;\n",
       "\n",
       "    var id = cell.output_area._bokeh_element_id;\n",
       "    var server_id = cell.output_area._bokeh_server_id;\n",
       "    // Clean up Bokeh references\n",
       "    if (id != null && id in Bokeh.index) {\n",
       "      Bokeh.index[id].model.document.clear();\n",
       "      delete Bokeh.index[id];\n",
       "    }\n",
       "\n",
       "    if (server_id !== undefined) {\n",
       "      // Clean up Bokeh references\n",
       "      var cmd = \"from bokeh.io.state import curstate; print(curstate().uuid_to_server['\" + server_id + \"'].get_sessions()[0].document.roots[0]._id)\";\n",
       "      cell.notebook.kernel.execute(cmd, {\n",
       "        iopub: {\n",
       "          output: function(msg) {\n",
       "            var id = msg.content.text.trim();\n",
       "            if (id in Bokeh.index) {\n",
       "              Bokeh.index[id].model.document.clear();\n",
       "              delete Bokeh.index[id];\n",
       "            }\n",
       "          }\n",
       "        }\n",
       "      });\n",
       "      // Destroy server and session\n",
       "      var cmd = \"import bokeh.io.notebook as ion; ion.destroy_server('\" + server_id + \"')\";\n",
       "      cell.notebook.kernel.execute(cmd);\n",
       "    }\n",
       "  }\n",
       "\n",
       "  /**\n",
       "   * Handle when a new output is added\n",
       "   */\n",
       "  function handleAddOutput(event, handle) {\n",
       "    var output_area = handle.output_area;\n",
       "    var output = handle.output;\n",
       "\n",
       "    // limit handleAddOutput to display_data with EXEC_MIME_TYPE content only\n",
       "    if ((output.output_type != \"display_data\") || (!output.data.hasOwnProperty(EXEC_MIME_TYPE))) {\n",
       "      return\n",
       "    }\n",
       "\n",
       "    var toinsert = output_area.element.find(\".\" + CLASS_NAME.split(' ')[0]);\n",
       "\n",
       "    if (output.metadata[EXEC_MIME_TYPE][\"id\"] !== undefined) {\n",
       "      toinsert[toinsert.length - 1].firstChild.textContent = output.data[JS_MIME_TYPE];\n",
       "      // store reference to embed id on output_area\n",
       "      output_area._bokeh_element_id = output.metadata[EXEC_MIME_TYPE][\"id\"];\n",
       "    }\n",
       "    if (output.metadata[EXEC_MIME_TYPE][\"server_id\"] !== undefined) {\n",
       "      var bk_div = document.createElement(\"div\");\n",
       "      bk_div.innerHTML = output.data[HTML_MIME_TYPE];\n",
       "      var script_attrs = bk_div.children[0].attributes;\n",
       "      for (var i = 0; i < script_attrs.length; i++) {\n",
       "        toinsert[toinsert.length - 1].firstChild.setAttribute(script_attrs[i].name, script_attrs[i].value);\n",
       "      }\n",
       "      // store reference to server id on output_area\n",
       "      output_area._bokeh_server_id = output.metadata[EXEC_MIME_TYPE][\"server_id\"];\n",
       "    }\n",
       "  }\n",
       "\n",
       "  function register_renderer(events, OutputArea) {\n",
       "\n",
       "    function append_mime(data, metadata, element) {\n",
       "      // create a DOM node to render to\n",
       "      var toinsert = this.create_output_subarea(\n",
       "        metadata,\n",
       "        CLASS_NAME,\n",
       "        EXEC_MIME_TYPE\n",
       "      );\n",
       "      this.keyboard_manager.register_events(toinsert);\n",
       "      // Render to node\n",
       "      var props = {data: data, metadata: metadata[EXEC_MIME_TYPE]};\n",
       "      render(props, toinsert[toinsert.length - 1]);\n",
       "      element.append(toinsert);\n",
       "      return toinsert\n",
       "    }\n",
       "\n",
       "    /* Handle when an output is cleared or removed */\n",
       "    events.on('clear_output.CodeCell', handleClearOutput);\n",
       "    events.on('delete.Cell', handleClearOutput);\n",
       "\n",
       "    /* Handle when a new output is added */\n",
       "    events.on('output_added.OutputArea', handleAddOutput);\n",
       "\n",
       "    /**\n",
       "     * Register the mime type and append_mime function with output_area\n",
       "     */\n",
       "    OutputArea.prototype.register_mime_type(EXEC_MIME_TYPE, append_mime, {\n",
       "      /* Is output safe? */\n",
       "      safe: true,\n",
       "      /* Index of renderer in `output_area.display_order` */\n",
       "      index: 0\n",
       "    });\n",
       "  }\n",
       "\n",
       "  // register the mime type if in Jupyter Notebook environment and previously unregistered\n",
       "  if (root.Jupyter !== undefined) {\n",
       "    var events = require('base/js/events');\n",
       "    var OutputArea = require('notebook/js/outputarea').OutputArea;\n",
       "\n",
       "    if (OutputArea.prototype.mime_types().indexOf(EXEC_MIME_TYPE) == -1) {\n",
       "      register_renderer(events, OutputArea);\n",
       "    }\n",
       "  }\n",
       "\n",
       "  \n",
       "  if (typeof (root._bokeh_timeout) === \"undefined\" || force === true) {\n",
       "    root._bokeh_timeout = Date.now() + 5000;\n",
       "    root._bokeh_failed_load = false;\n",
       "  }\n",
       "\n",
       "  var NB_LOAD_WARNING = {'data': {'text/html':\n",
       "     \"<div style='background-color: #fdd'>\\n\"+\n",
       "     \"<p>\\n\"+\n",
       "     \"BokehJS does not appear to have successfully loaded. If loading BokehJS from CDN, this \\n\"+\n",
       "     \"may be due to a slow or bad network connection. Possible fixes:\\n\"+\n",
       "     \"</p>\\n\"+\n",
       "     \"<ul>\\n\"+\n",
       "     \"<li>re-rerun `output_notebook()` to attempt to load from CDN again, or</li>\\n\"+\n",
       "     \"<li>use INLINE resources instead, as so:</li>\\n\"+\n",
       "     \"</ul>\\n\"+\n",
       "     \"<code>\\n\"+\n",
       "     \"from bokeh.resources import INLINE\\n\"+\n",
       "     \"output_notebook(resources=INLINE)\\n\"+\n",
       "     \"</code>\\n\"+\n",
       "     \"</div>\"}};\n",
       "\n",
       "  function display_loaded() {\n",
       "    var el = document.getElementById(\"1001\");\n",
       "    if (el != null) {\n",
       "      el.textContent = \"BokehJS is loading...\";\n",
       "    }\n",
       "    if (root.Bokeh !== undefined) {\n",
       "      if (el != null) {\n",
       "        el.textContent = \"BokehJS \" + root.Bokeh.version + \" successfully loaded.\";\n",
       "      }\n",
       "    } else if (Date.now() < root._bokeh_timeout) {\n",
       "      setTimeout(display_loaded, 100)\n",
       "    }\n",
       "  }\n",
       "\n",
       "\n",
       "  function run_callbacks() {\n",
       "    try {\n",
       "      root._bokeh_onload_callbacks.forEach(function(callback) { callback() });\n",
       "    }\n",
       "    finally {\n",
       "      delete root._bokeh_onload_callbacks\n",
       "    }\n",
       "    console.info(\"Bokeh: all callbacks have finished\");\n",
       "  }\n",
       "\n",
       "  function load_libs(js_urls, callback) {\n",
       "    root._bokeh_onload_callbacks.push(callback);\n",
       "    if (root._bokeh_is_loading > 0) {\n",
       "      console.log(\"Bokeh: BokehJS is being loaded, scheduling callback at\", now());\n",
       "      return null;\n",
       "    }\n",
       "    if (js_urls == null || js_urls.length === 0) {\n",
       "      run_callbacks();\n",
       "      return null;\n",
       "    }\n",
       "    console.log(\"Bokeh: BokehJS not loaded, scheduling load and callback at\", now());\n",
       "    root._bokeh_is_loading = js_urls.length;\n",
       "    for (var i = 0; i < js_urls.length; i++) {\n",
       "      var url = js_urls[i];\n",
       "      var s = document.createElement('script');\n",
       "      s.src = url;\n",
       "      s.async = false;\n",
       "      s.onreadystatechange = s.onload = function() {\n",
       "        root._bokeh_is_loading--;\n",
       "        if (root._bokeh_is_loading === 0) {\n",
       "          console.log(\"Bokeh: all BokehJS libraries loaded\");\n",
       "          run_callbacks()\n",
       "        }\n",
       "      };\n",
       "      s.onerror = function() {\n",
       "        console.warn(\"failed to load library \" + url);\n",
       "      };\n",
       "      console.log(\"Bokeh: injecting script tag for BokehJS library: \", url);\n",
       "      document.getElementsByTagName(\"head\")[0].appendChild(s);\n",
       "    }\n",
       "  };var element = document.getElementById(\"1001\");\n",
       "  if (element == null) {\n",
       "    console.log(\"Bokeh: ERROR: autoload.js configured with elementid '1001' but no matching script tag was found. \")\n",
       "    return false;\n",
       "  }\n",
       "\n",
       "  var js_urls = [\"https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-gl-1.0.4.min.js\"];\n",
       "\n",
       "  var inline_js = [\n",
       "    function(Bokeh) {\n",
       "      Bokeh.set_log_level(\"info\");\n",
       "    },\n",
       "    \n",
       "    function(Bokeh) {\n",
       "      \n",
       "    },\n",
       "    function(Bokeh) {\n",
       "      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css\");\n",
       "      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css\");\n",
       "      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css\");\n",
       "      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css\");\n",
       "      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css\");\n",
       "      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css\");\n",
       "    }\n",
       "  ];\n",
       "\n",
       "  function run_inline_js() {\n",
       "    \n",
       "    if ((root.Bokeh !== undefined) || (force === true)) {\n",
       "      for (var i = 0; i < inline_js.length; i++) {\n",
       "        inline_js[i].call(root, root.Bokeh);\n",
       "      }if (force === true) {\n",
       "        display_loaded();\n",
       "      }} else if (Date.now() < root._bokeh_timeout) {\n",
       "      setTimeout(run_inline_js, 100);\n",
       "    } else if (!root._bokeh_failed_load) {\n",
       "      console.log(\"Bokeh: BokehJS failed to load within specified timeout.\");\n",
       "      root._bokeh_failed_load = true;\n",
       "    } else if (force !== true) {\n",
       "      var cell = $(document.getElementById(\"1001\")).parents('.cell').data().cell;\n",
       "      cell.output_area.append_execute_result(NB_LOAD_WARNING)\n",
       "    }\n",
       "\n",
       "  }\n",
       "\n",
       "  if (root._bokeh_is_loading === 0) {\n",
       "    console.log(\"Bokeh: BokehJS loaded, going straight to plotting\");\n",
       "    run_inline_js();\n",
       "  } else {\n",
       "    load_libs(js_urls, function() {\n",
       "      console.log(\"Bokeh: BokehJS plotting callback run at\", now());\n",
       "      run_inline_js();\n",
       "    });\n",
       "  }\n",
       "}(window));"
      ],
      "application/vnd.bokehjs_load.v0+json": "\n(function(root) {\n  function now() {\n    return new Date();\n  }\n\n  var force = true;\n\n  if (typeof (root._bokeh_onload_callbacks) === \"undefined\" || force === true) {\n    root._bokeh_onload_callbacks = [];\n    root._bokeh_is_loading = undefined;\n  }\n\n  \n\n  \n  if (typeof (root._bokeh_timeout) === \"undefined\" || force === true) {\n    root._bokeh_timeout = Date.now() + 5000;\n    root._bokeh_failed_load = false;\n  }\n\n  var NB_LOAD_WARNING = {'data': {'text/html':\n     \"<div style='background-color: #fdd'>\\n\"+\n     \"<p>\\n\"+\n     \"BokehJS does not appear to have successfully loaded. If loading BokehJS from CDN, this \\n\"+\n     \"may be due to a slow or bad network connection. Possible fixes:\\n\"+\n     \"</p>\\n\"+\n     \"<ul>\\n\"+\n     \"<li>re-rerun `output_notebook()` to attempt to load from CDN again, or</li>\\n\"+\n     \"<li>use INLINE resources instead, as so:</li>\\n\"+\n     \"</ul>\\n\"+\n     \"<code>\\n\"+\n     \"from bokeh.resources import INLINE\\n\"+\n     \"output_notebook(resources=INLINE)\\n\"+\n     \"</code>\\n\"+\n     \"</div>\"}};\n\n  function display_loaded() {\n    var el = document.getElementById(\"1001\");\n    if (el != null) {\n      el.textContent = \"BokehJS is loading...\";\n    }\n    if (root.Bokeh !== undefined) {\n      if (el != null) {\n        el.textContent = \"BokehJS \" + root.Bokeh.version + \" successfully loaded.\";\n      }\n    } else if (Date.now() < root._bokeh_timeout) {\n      setTimeout(display_loaded, 100)\n    }\n  }\n\n\n  function run_callbacks() {\n    try {\n      root._bokeh_onload_callbacks.forEach(function(callback) { callback() });\n    }\n    finally {\n      delete root._bokeh_onload_callbacks\n    }\n    console.info(\"Bokeh: all callbacks have finished\");\n  }\n\n  function load_libs(js_urls, callback) {\n    root._bokeh_onload_callbacks.push(callback);\n    if (root._bokeh_is_loading > 0) {\n      console.log(\"Bokeh: BokehJS is being loaded, scheduling callback at\", now());\n      return null;\n    }\n    if (js_urls == null || js_urls.length === 0) {\n      run_callbacks();\n      return null;\n    }\n    console.log(\"Bokeh: BokehJS not loaded, scheduling load and callback at\", now());\n    root._bokeh_is_loading = js_urls.length;\n    for (var i = 0; i < js_urls.length; i++) {\n      var url = js_urls[i];\n      var s = document.createElement('script');\n      s.src = url;\n      s.async = false;\n      s.onreadystatechange = s.onload = function() {\n        root._bokeh_is_loading--;\n        if (root._bokeh_is_loading === 0) {\n          console.log(\"Bokeh: all BokehJS libraries loaded\");\n          run_callbacks()\n        }\n      };\n      s.onerror = function() {\n        console.warn(\"failed to load library \" + url);\n      };\n      console.log(\"Bokeh: injecting script tag for BokehJS library: \", url);\n      document.getElementsByTagName(\"head\")[0].appendChild(s);\n    }\n  };var element = document.getElementById(\"1001\");\n  if (element == null) {\n    console.log(\"Bokeh: ERROR: autoload.js configured with elementid '1001' but no matching script tag was found. \")\n    return false;\n  }\n\n  var js_urls = [\"https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-gl-1.0.4.min.js\"];\n\n  var inline_js = [\n    function(Bokeh) {\n      Bokeh.set_log_level(\"info\");\n    },\n    \n    function(Bokeh) {\n      \n    },\n    function(Bokeh) {\n      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css\");\n      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css\");\n      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css\");\n      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css\");\n      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css\");\n      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css\");\n    }\n  ];\n\n  function run_inline_js() {\n    \n    if ((root.Bokeh !== undefined) || (force === true)) {\n      for (var i = 0; i < inline_js.length; i++) {\n        inline_js[i].call(root, root.Bokeh);\n      }if (force === true) {\n        display_loaded();\n      }} else if (Date.now() < root._bokeh_timeout) {\n      setTimeout(run_inline_js, 100);\n    } else if (!root._bokeh_failed_load) {\n      console.log(\"Bokeh: BokehJS failed to load within specified timeout.\");\n      root._bokeh_failed_load = true;\n    } else if (force !== true) {\n      var cell = $(document.getElementById(\"1001\")).parents('.cell').data().cell;\n      cell.output_area.append_execute_result(NB_LOAD_WARNING)\n    }\n\n  }\n\n  if (root._bokeh_is_loading === 0) {\n    console.log(\"Bokeh: BokehJS loaded, going straight to plotting\");\n    run_inline_js();\n  } else {\n    load_libs(js_urls, function() {\n      console.log(\"Bokeh: BokehJS plotting callback run at\", now());\n      run_inline_js();\n    });\n  }\n}(window));"
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "import requests\n",
    "import pandas_bokeh\n",
    "pandas_bokeh.output_notebook()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Ready-mix optimization"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 186,
   "metadata": {},
   "outputs": [],
   "source": [
    "from geopy.distance import geodesic\n",
    "import time"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### geo_map maps plant and JobSiteCodes to their lat/lon centroids"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 699,
   "metadata": {},
   "outputs": [],
   "source": [
    "geo_map = None\n",
    "with open(\"geo_map.json\", \"rt\") as in_file:\n",
    "    geo_map = json.loads(in_file.read())"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Input JSON config data (plants and deliveries)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 678,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "2019-08-12\n",
      "2019-08-13\n",
      "2019-08-14\n",
      "2019-08-15\n",
      "2019-08-16\n"
     ]
    }
   ],
   "source": [
    "import json\n",
    "info_map = {}\n",
    "\n",
    "date_pick = [\n",
    "    \"2019-08-12\",\n",
    "    \"2019-08-13\",\n",
    "    \"2019-08-14\",\n",
    "    \"2019-08-15\",\n",
    "    \"2019-08-16\"\n",
    "]\n",
    "\n",
    "for date_v in date_pick:\n",
    "    print(date_v)\n",
    "    with open(\"info_{}.json\".format(date_v), \"rt\") as in_file:\n",
    "        info = json.loads(in_file.read())\n",
    "        info_map[date_v] = info"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": 324,
   "metadata": {},
   "outputs": [],
   "source": [
    "ratio_duration_at_client = 0.432\n",
    "\n",
    "class GraphAdapter:\n",
    "    \n",
    "    def __init__(self):\n",
    "        self._G = nx.DiGraph()\n",
    "        self._node_index = 0\n",
    "        self._nodes_m = {}\n",
    "        \n",
    "    def add_node(self, key, label, attr=None):\n",
    "        self._nodes_m[key] = self._node_index\n",
    "        self._G.add_node(self._node_index, label=label)\n",
    "        if attr is not None:\n",
    "            for key, value in attr.items():\n",
    "                self._G.nodes[self._node_index][key] = value\n",
    "        ret_index = self._node_index\n",
    "        self._node_index += 1\n",
    "        return ret_index\n",
    "    \n",
    "    def get_node(self, key):\n",
    "        return self._nodes_m[key]\n",
    "\n",
    "    def add_edge(self, nodeFrom, nodeTo, capacity, cost, attr=None):\n",
    "        self._G.add_edge(nodeFrom, nodeTo)\n",
    "        self._G[nodeFrom][nodeTo][\"capacity\"] = capacity\n",
    "        self._G[nodeFrom][nodeTo][\"cost\"] = cost\n",
    "        if attr is not None:\n",
    "            for key, value in attr.items():\n",
    "                self._G[nodeFrom][nodeTo][key] = value\n",
    "        #edges[\"{},{}\".format(nodeFrom, nodeTo)] = (capacity, cost)\n",
    "        \n",
    "    def getG(self):\n",
    "        return self._G\n",
    "    \n",
    "    def getNodeMap(self):\n",
    "        return self._nodes_m\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### Create optimization graph"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 682,
   "metadata": {},
   "outputs": [],
   "source": [
    "\n",
    "\n",
    "def greatCircleDistance(x, y):\n",
    "    lat1, lon1 = x[1], x[0]\n",
    "    lat2, lon2 = y[1], y[0]\n",
    "    return geodesic((lat1, lon1), (lat2, lon2)).meters\n",
    "    \n",
    "def compute_driving_cost(plant_drive_model, client_info):\n",
    "    A = plant_drive_model[\"A\"]\n",
    "    b = plant_drive_model[\"b\"]\n",
    "    plant_coordinates = plant_drive_model[\"centroid\"]\n",
    "    client_coordinates = client_info[\"centroid\"]\n",
    "    PlantJobDistance = greatCircleDistance(plant_coordinates, client_coordinates)\n",
    "    fix_velocity = 30*0.277778 # m/s\n",
    "    duration_fix = PlantJobDistance/fix_velocity\n",
    "    \n",
    "    estimated_duration_all = A*PlantJobDistance + b\n",
    "    estimated_duration_at_client = ratio_duration_at_client * estimated_duration_all\n",
    "    estimated_duration_to_client = (estimated_duration_all - estimated_duration_at_client)/2.0\n",
    "    estimated_duration_to_client_sec = estimated_duration_to_client * 60.0\n",
    "    #return PlantJobDistance, estimated_duration_to_client_sec\n",
    "    return PlantJobDistance, duration_fix\n",
    "    \n",
    "def create_optimization_graph(info, time_interval=3600):\n",
    "\n",
    "    #info[\"plants\"] # plant_id, start_time, end_time, load_time, time_interval, truck_capacity\n",
    "    #info[\"deliveries\"] # client_id, arrival_time, pour_duration, revenue\n",
    "    #info[\"cost_to_client\"] # travel cost from plant_id to client_id\n",
    "    #info[\"cost_from_client\"] # travel cost from client_id to plant_id\n",
    "        \n",
    "    g = GraphAdapter()\n",
    "        \n",
    "    #create supersource node\n",
    "    key = \"super_source::\"\n",
    "    g.add_node(key, label=\"super_source\")\n",
    "    superSource = g.get_node(key)\n",
    "    #create supersink node\n",
    "    key = \"super_sink::\"\n",
    "    g.add_node(key, label=\"super_sink\")\n",
    "    superSink = g.get_node(key)\n",
    "\n",
    "    #loop through deliveries\n",
    "    client_exits = {}\n",
    "    for _, item in info[\"deliveries\"].items():\n",
    "        #client arrival\n",
    "        key = \"client_arrival:{}:{}\".format(item[\"client_id\"], item[\"arrival_time\"])\n",
    "        node1 = g.add_node(key, label=\"client_arrival\", attr={\n",
    "            \"client_id\": item[\"client_id\"], \n",
    "            \"arrival_time\": item[\"arrival_time\"],\n",
    "            \"pour_duration\": item[\"pour_duration\"]\n",
    "        })\n",
    "        #client exit\n",
    "        exit_time = item[\"arrival_time\"] + item[\"pour_duration\"]\n",
    "        key = \"client_exit:{}:{}\".format(item[\"client_id\"], exit_time)\n",
    "        node2 = g.add_node(key, label=\"client_exit\", attr={\n",
    "            \"client_id\": item[\"client_id\"],\n",
    "            \"exit_time\": exit_time,\n",
    "            \"pour_duration\": item[\"pour_duration\"], \n",
    "            \"arrival_time\": item[\"arrival_time\"]\n",
    "        })\n",
    "        #add edge between client delivery and exist with the revenue as positive cost\n",
    "        g.add_edge(node1, node2, 1, -1 * item[\"revenue\"] * 10000)\n",
    "        \n",
    "        client_exits[key] = {\n",
    "            \"client_id\": item[\"client_id\"],\n",
    "            \"exit_time\": exit_time\n",
    "        }\n",
    "        \n",
    "    last_time_nodes = []\n",
    "    #loop through the plants\n",
    "    for _, plant in info[\"plants\"].items():\n",
    "        prevTimeNode = None\n",
    "        \n",
    "        plant_drive_model = info[\"driving_model_data\"][\"plant_data\"][plant[\"plant_id\"]]\n",
    "        \n",
    "        latest_time_node = None\n",
    "        #for t in range(plant[\"start_time\"], plant[\"end_time\"], plant[\"time_interval\"]):\n",
    "        for t in range(plant[\"start_time\"], plant[\"end_time\"], time_interval):\n",
    "            #plant+time node\n",
    "            key = \"plant_time:{}:{}\".format(plant[\"plant_id\"],t)\n",
    "            node1 = g.add_node(key, label=\"plant_time\", attr={\n",
    "                \"plant_id\": plant[\"plant_id\"],\n",
    "                \"time\": t\n",
    "            })\n",
    "            latest_time_node = node1\n",
    "            #plant+time-load node\n",
    "            key = key = \"plant_time_load:{}:{}\".format(plant[\"plant_id\"],t)\n",
    "            loadNode = g.add_node(key, label=\"plant_time_load\", attr={\n",
    "                \"plant_id\": plant[\"plant_id\"],\n",
    "                \"time\": t\n",
    "            })\n",
    "            #add edge between the plant-time node and the plant+time-load node\n",
    "            g.add_edge(node1, loadNode, 1, time_interval) # putting fixed five finutes as we don't have this time\n",
    "            \n",
    "            if prevTimeNode is not None:\n",
    "                #add edge from prevous time node to current time node\n",
    "                g.add_edge(prevTimeNode, node1, 100000, 1) # \n",
    "            else:\n",
    "                #then this is the first time node for the plant, so need to connect it to the super source\n",
    "                g.add_edge(superSource, node1, plant[\"truck_capacity\"], 0)\n",
    "                \n",
    "            prevTimeNode = node1\n",
    "            \n",
    "            #loop through the deliveries\n",
    "            for _, c in info[\"deliveries\"].items():\n",
    "                # if the time of the load node + travel time <= required arrival, then create the connection\n",
    "                distance, travel_cost = compute_driving_cost(plant_drive_model, \n",
    "                                     info[\"driving_model_data\"][\"client_data\"][c[\"client_id\"]])\n",
    "                if ((t + travel_cost) <= c[\"arrival_time\"]) and \\\n",
    "                   ((t + 90*60) >= c[\"arrival_time\"]):\n",
    "                    key = \"client_arrival:{}:{}\".format(c[\"client_id\"], c[\"arrival_time\"])\n",
    "                    clientArrival = g.get_node(key)\n",
    "                    #actual_cost = (c[\"arrival_time\"] - t)\n",
    "                    actual_cost = (c[\"arrival_time\"] - t)\n",
    "                    g.add_edge(loadNode, clientArrival, 1, actual_cost, attr={\n",
    "                        \"distance\": distance,\n",
    "                        \"duration\": actual_cost,\n",
    "                        \"estimated_duration\": travel_cost\n",
    "                    })\n",
    "                    \n",
    "        last_time_nodes.append((latest_time_node, plant[\"truck_capacity\"]))\n",
    "                    \n",
    "    #loop through the client exits and find the closest plant time to return to for each plant\n",
    "    for exit_key, exit_info in client_exits.items():\n",
    "        for _, plant in info[\"plants\"].items():\n",
    "            plant_drive_model = info[\"driving_model_data\"][\"plant_data\"][plant[\"plant_id\"]]\n",
    "            distance, travel_cost = compute_driving_cost(plant_drive_model, \n",
    "                             info[\"driving_model_data\"][\"client_data\"][exit_info[\"client_id\"]])\n",
    "            for t in range(plant[\"start_time\"], plant[\"end_time\"], time_interval):\n",
    "                if ((exit_info[\"exit_time\"] + travel_cost) <= t):\n",
    "                    # add edge between exit time and \n",
    "                    exitNode = g.get_node(exit_key)\n",
    "                    actual_cost = (t - exit_info[\"exit_time\"])\n",
    "                    key = \"plant_time:{}:{}\".format(plant[\"plant_id\"],t)\n",
    "                    plant_time_node = g.get_node(key)\n",
    "                    g.add_edge(exitNode, plant_time_node, 1, actual_cost, attr={\n",
    "                        \"distance\": distance,\n",
    "                        \"duration\": actual_cost,\n",
    "                        \"estimated_duration\": travel_cost\n",
    "                    })\n",
    "                    break\n",
    "                    \n",
    "    for time_node, truck_capacity in last_time_nodes:\n",
    "        g.add_edge(time_node, superSink, truck_capacity, 0)\n",
    "    \n",
    "    return g\n",
    "    "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "##### Solve optimization problem "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 683,
   "metadata": {},
   "outputs": [],
   "source": [
    "def main(g, total_number_trucks=47):\n",
    "    \"\"\"MinCostFlow for ready-mix concrete route optimization.\"\"\"\n",
    "    \n",
    "    # Define four parallel arrays: start_nodes, end_nodes, capacities, and unit costs\n",
    "    # between each pair. For instance, the arc from node 0 to node 1 has a\n",
    "    # capacity of 15 and a unit cost of 4.\n",
    "    \n",
    "    start_nodes = []  \n",
    "    end_nodes   = []\n",
    "    capacities  = []\n",
    "    unit_costs  = []\n",
    "    \n",
    "    for edge in g.getG().edges:\n",
    "        start_nodes.append(edge[0])\n",
    "        end_nodes.append(edge[1])\n",
    "        capacities.append(g.getG().edges[edge[0], edge[1]]['capacity'])\n",
    "        unit_costs.append(int(g.getG().edges[edge[0], edge[1]]['cost']))\n",
    "    \n",
    "    # Define an array of supplies at each node.\n",
    "\n",
    "    supplies = [total_number_trucks, -total_number_trucks]\n",
    "    for i in range(2, g.getG().number_of_nodes()):\n",
    "        supplies.append(0)\n",
    "        \n",
    "    print(len(start_nodes))\n",
    "    print(len(end_nodes))\n",
    "    print(len(capacities))\n",
    "    print(len(unit_costs))\n",
    "    print(len(supplies))\n",
    "    \n",
    "    # Instantiate a SimpleMinCostFlow solver.\n",
    "    min_cost_flow = pywrapgraph.SimpleMinCostFlow()\n",
    "    \n",
    "    # Add each arc.\n",
    "    for i in range(0, len(start_nodes)):\n",
    "        min_cost_flow.AddArcWithCapacityAndUnitCost(start_nodes[i], end_nodes[i],\n",
    "                                                capacities[i], unit_costs[i])\n",
    "    \n",
    "    # Add node supplies.\n",
    "    for i in range(0, len(supplies)):\n",
    "        min_cost_flow.SetNodeSupply(i, supplies[i])\n",
    "        \n",
    "    # Find the minimum cost flow between node 0 and node 4.\n",
    "    xx = min_cost_flow.Solve()\n",
    "    print(\"min_cost_flow.Solve() = {}\".format(xx))\n",
    "    plant_df = None\n",
    "    if xx == min_cost_flow.OPTIMAL:\n",
    "        print('Flow cost of the min flow cost', min_cost_flow.MaximumFlow())\n",
    "        print('Minimum cost:', min_cost_flow.OptimalCost())\n",
    "        print('')\n",
    "        print('  Arc    Flow / Capacity  Cost')\n",
    "        total_distance = 0\n",
    "        total_duration = 0\n",
    "        total_duration_est = 0\n",
    "        total_distance_client = 0\n",
    "        total_duration_client = 0\n",
    "        total_duration_est_client = 0\n",
    "        number_client_exists = 0\n",
    "        delivery_info = {}\n",
    "        plant_info = {}\n",
    "        plant_stats = {}\n",
    "        client_id = '66646736'\n",
    "        for i in range(min_cost_flow.NumArcs()):\n",
    "            cost = min_cost_flow.Flow(i) * min_cost_flow.UnitCost(i)\n",
    "            if min_cost_flow.Flow(i) > 0 and False:\n",
    "                print(',%1s -> %1s,   %3s  / %3s       %3s' % (\n",
    "                  min_cost_flow.Tail(i),\n",
    "                  min_cost_flow.Head(i),\n",
    "                  min_cost_flow.Flow(i),\n",
    "                  min_cost_flow.Capacity(i),\n",
    "                cost))\n",
    "            \n",
    "            if min_cost_flow.Flow(i) > 0:\n",
    "                src = min_cost_flow.Tail(i)\n",
    "                srcn = g.getG().nodes[src]\n",
    "                dst = min_cost_flow.Head(i)\n",
    "                dstn = g.getG().nodes[dst]\n",
    "                if srcn[\"label\"].startswith(\"plant_time_load\"):\n",
    "                    ll = plant_info.setdefault(srcn[\"plant_id\"], [])\n",
    "                    if dstn[\"label\"] != \"super_sink\":\n",
    "                        arrival_time = strftime(dstn[\"arrival_time\"])\n",
    "                        edge = g.getG().edges[src, dst]\n",
    "                        ll.append({\n",
    "                            \"plant_time\": strftime(srcn[\"time\"]),\n",
    "                            \"exp_time_back\": strftime(srcn[\"time\"] + 2*edge[\"duration\"] + dstn[\"pour_duration\"]),\n",
    "                            \"label\": \"arrival\", \n",
    "                            \"client_id\": dstn[\"client_id\"], \n",
    "                            \"arrival_time\": arrival_time,\n",
    "                            \"distance\": edge[\"distance\"],\n",
    "                            \"estimated_duration\": edge[\"estimated_duration\"],\n",
    "                            \"duration\": edge[\"duration\"]\n",
    "                            \n",
    "                        })\n",
    "                        m = plant_stats.setdefault(srcn[\"plant_id\"], {})\n",
    "                        m.setdefault(\"send\", 0)\n",
    "                        m[\"send\"] += 1\n",
    "                    else:\n",
    "                        ll.append(dstn)\n",
    "                if dstn[\"label\"] == \"plant_time\" and srcn[\"label\"] != \"plant_time\":\n",
    "                    ll = plant_info.setdefault(dstn[\"plant_id\"], [])\n",
    "                    if srcn[\"label\"] != \"super_source\":\n",
    "                        exit_time = strftime(srcn[\"exit_time\"])\n",
    "                        edge = g.getG().edges[src, dst]\n",
    "                        ll.append({\n",
    "                            \"plant_time\": strftime(dstn[\"time\"]),\n",
    "                            \"label\": \"exit\", \n",
    "                            \"client_id\": srcn[\"client_id\"], \n",
    "                            \"exit_time\": exit_time,\n",
    "                            \"distance\": edge[\"distance\"],\n",
    "                            \"estimated_duration\": edge[\"estimated_duration\"],\n",
    "                            \"duration\": edge[\"duration\"]\n",
    "                        })\n",
    "                        m = plant_stats.setdefault(dstn[\"plant_id\"], {})\n",
    "                        m.setdefault(\"recv\", 0)\n",
    "                        m[\"recv\"] += 1\n",
    "                    else:\n",
    "                        ll.append(srcn)\n",
    "                if srcn[\"label\"].startswith(\"client_exit\"):\n",
    "                    # then from client to plant\n",
    "                    dist = g.getG().edges[src, dst][\"distance\"]\n",
    "                    dur = g.getG().edges[src, dst][\"duration\"]\n",
    "                    est_dur = g.getG().edges[src, dst][\"estimated_duration\"]\n",
    "                    total_distance += dist\n",
    "                    total_duration += dur\n",
    "                    total_duration_est += est_dur\n",
    "                    #print(dist)\n",
    "                    number_client_exists += 1\n",
    "                    m = delivery_info.setdefault(\"{}_{}\".format(src, srcn[\"client_id\"]), {})\n",
    "                    arrival_time = strftime(srcn[\"arrival_time\"])\n",
    "                    ll = m.setdefault(arrival_time, [])\n",
    "                    ll.append((\"TO:\",dstn[\"plant_id\"], dist, dur/60.0, est_dur/60.0))\n",
    "                    if srcn[\"client_id\"] == client_id:\n",
    "                        total_distance_client += dist\n",
    "                        total_duration_client += dur\n",
    "                        total_duration_est_client += est_dur\n",
    "                if dstn[\"label\"].startswith(\"client_arrival\"):\n",
    "                    # then from plant to client\n",
    "                    dist = g.getG().edges[src, dst][\"distance\"]\n",
    "                    dur = g.getG().edges[src, dst][\"duration\"]\n",
    "                    est_dur = g.getG().edges[src, dst][\"estimated_duration\"]\n",
    "                    total_distance += dist\n",
    "                    total_duration += dur\n",
    "                    total_duration_est += est_dur\n",
    "                    m = delivery_info.setdefault(\"{}_{}\".format(dst+1, dstn[\"client_id\"]), {})\n",
    "                    arrival_time = strftime(dstn[\"arrival_time\"])\n",
    "                    ll = m.setdefault(arrival_time, [])\n",
    "                    ll.append((\"FROM:\",srcn[\"plant_id\"], dist, dur/60.0, est_dur/60.0))\n",
    "                    if dstn[\"client_id\"] == client_id:\n",
    "                        total_distance_client += dist\n",
    "                        total_duration_client += dur\n",
    "                        total_duration_est_client += est_dur\n",
    "                    \n",
    "        print(\"total_distance: {}\".format(total_distance))\n",
    "        print(\"total_duration: {}\".format(total_duration))\n",
    "        print(\"total_duration_est: {}\".format(total_duration_est))\n",
    "        print(\"total_distance_client: {}\".format(total_distance_client))\n",
    "        print(\"total_duration_client: {}\".format(total_duration_client))\n",
    "        print(\"total_duration_est_client: {}\".format(total_duration_est_client))\n",
    "        print(\"number_client_exists: {}\".format(number_client_exists))\n",
    "        for cid, info in delivery_info.items():\n",
    "            if client_id in cid:\n",
    "                print(\"client: {}\".format(cid))\n",
    "                for tt, info2 in info.items():\n",
    "                    print(\"\\tarrival: {}:\".format(tt))\n",
    "                    for z in info2[::-1]:\n",
    "                        print(\"\\t\\t{}\".format(z))\n",
    "        for pid, info in plant_stats.items():\n",
    "            print(\"plant: {}\".format(pid))\n",
    "            print(\"\\tsend: {}\".format(info[\"send\"]))\n",
    "            print(\"\\trecv: {}\".format(info[\"recv\"]))\n",
    "    \n",
    "        data = []\n",
    "        for pid, item_list in plant_info.items():\n",
    "            print(\"plant: {}\".format(pid))\n",
    "            sorted_list = sorted([x for x in item_list if x[\"label\"] == \"exit\" or x[\"label\"] == \"arrival\"], key=lambda x: x[\"arrival_time\"] if \"arrival_time\" in x else x[\"exit_time\"])\n",
    "            for item in sorted_list:\n",
    "                #print(\"\\t{}\".format(item))\n",
    "                record = [pid, \n",
    "                          item[\"plant_time\"],\n",
    "                          item[\"exp_time_back\"] if \"arrival_time\" in item else None,\n",
    "                          \"arrival\" if \"arrival_time\" in item else \"exit\",\n",
    "                          item[\"client_id\"], \n",
    "                          item[\"arrival_time\"] if \"arrival_time\" in item else item[\"exit_time\"],\n",
    "                          item[\"distance\"]/1000.0,\n",
    "                          item[\"estimated_duration\"]/60.0,\n",
    "                          item[\"duration\"]/60.0\n",
    "                         ]\n",
    "                data.append(record)\n",
    "        plant_df = pd.DataFrame(data, columns=[\n",
    "            \"Plant\", \"PTime\", \"ExpTimeBack\", \"OType\", \"Client\", \"Time\", \"Dist(km)\", \"EstDur(m)\", \"Dur(m)\"\n",
    "        ])\n",
    "    else:\n",
    "        print('There was an issue with the min cost flow input.')\n",
    "    return plant_df"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 698,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Date: 2019-08-12\n",
      "\n",
      "total_number_trucks = 25\n",
      "num_deliveries = 32\n",
      "2410\n",
      "2410\n",
      "2410\n",
      "2410\n",
      "1274\n",
      "min_cost_flow.Solve() = 1\n",
      "Flow cost of the min flow cost 25\n",
      "Minimum cost: -977174292\n",
      "\n",
      "  Arc    Flow / Capacity  Cost\n",
      "total_distance: 315335.1156469573\n",
      "total_duration: 47476.56767630577\n",
      "total_duration_est: 37840.183605487975\n",
      "total_distance_client: 0\n",
      "total_duration_client: 0\n",
      "total_duration_est_client: 0\n",
      "number_client_exists: 31\n",
      "plant: FB40\n",
      "\tsend: 6\n",
      "\trecv: 6\n",
      "plant: F011\n",
      "\tsend: 8\n",
      "\trecv: 8\n",
      "plant: FB25\n",
      "\tsend: 12\n",
      "\trecv: 12\n",
      "plant: FB58\n",
      "\tsend: 5\n",
      "\trecv: 5\n",
      "plant: F011\n",
      "plant: FB25\n",
      "plant: FB40\n",
      "plant: FB58\n",
      "Date: 2019-08-13\n",
      "\n",
      "total_number_trucks = 41\n",
      "num_deliveries = 82\n",
      "4396\n",
      "4396\n",
      "4396\n",
      "4396\n",
      "1558\n",
      "min_cost_flow.Solve() = 1\n",
      "Flow cost of the min flow cost 41\n",
      "Minimum cost: -2581617316\n",
      "\n",
      "  Arc    Flow / Capacity  Cost\n",
      "total_distance: 1173996.4504975292\n",
      "total_duration: 167218.58179664612\n",
      "total_duration_est: 140879.46135613447\n",
      "total_distance_client: 0\n",
      "total_duration_client: 0\n",
      "total_duration_est_client: 0\n",
      "number_client_exists: 80\n",
      "plant: FB25\n",
      "\tsend: 26\n",
      "\trecv: 26\n",
      "plant: FB40\n",
      "\tsend: 21\n",
      "\trecv: 21\n",
      "plant: F011\n",
      "\tsend: 26\n",
      "\trecv: 26\n",
      "plant: FB58\n",
      "\tsend: 7\n",
      "\trecv: 7\n",
      "plant: F011\n",
      "plant: FB25\n",
      "plant: FB40\n",
      "plant: FB58\n",
      "Date: 2019-08-14\n",
      "\n",
      "total_number_trucks = 47\n",
      "num_deliveries = 66\n",
      "4689\n",
      "4689\n",
      "4689\n",
      "4689\n",
      "2270\n",
      "min_cost_flow.Solve() = 1\n",
      "Flow cost of the min flow cost 47\n",
      "Minimum cost: -2274674352\n",
      "\n",
      "  Arc    Flow / Capacity  Cost\n",
      "total_distance: 906982.0833556547\n",
      "total_duration: 129216.53535866737\n",
      "total_duration_est: 108837.76293246816\n",
      "total_distance_client: 0\n",
      "total_duration_client: 0\n",
      "total_duration_est_client: 0\n",
      "number_client_exists: 66\n",
      "plant: F011\n",
      "\tsend: 24\n",
      "\trecv: 24\n",
      "plant: FB25\n",
      "\tsend: 15\n",
      "\trecv: 15\n",
      "plant: FB40\n",
      "\tsend: 23\n",
      "\trecv: 23\n",
      "plant: FB58\n",
      "\tsend: 4\n",
      "\trecv: 4\n",
      "plant: F011\n",
      "plant: FB25\n",
      "plant: FB40\n",
      "plant: FB58\n",
      "Date: 2019-08-15\n",
      "\n",
      "total_number_trucks = 47\n",
      "num_deliveries = 109\n",
      "5965\n",
      "5965\n",
      "5965\n",
      "5965\n",
      "2196\n",
      "min_cost_flow.Solve() = 1\n",
      "Flow cost of the min flow cost 47\n",
      "Minimum cost: -3501373334\n",
      "\n",
      "  Arc    Flow / Capacity  Cost\n",
      "total_distance: 1842714.825921216\n",
      "total_duration: 256732.8052558899\n",
      "total_duration_est: 221125.6022100641\n",
      "total_distance_client: 137426.6317754299\n",
      "total_duration_client: 19377.034125328064\n",
      "total_duration_est_client: 16491.182620105486\n",
      "number_client_exists: 108\n",
      "client: 7_66646736\n",
      "\tarrival: 2019-08-15 20:33:24 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 19.66438116232554, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 18.651771438121795, 17.178315229276553)\n",
      "client: 23_66646736\n",
      "\tarrival: 2019-08-15 18:38:08 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 19.396057772636414, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 20.525431815783183, 17.178315229276553)\n",
      "client: 37_66646736\n",
      "\tarrival: 2019-08-15 19:48:43 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 19.979391105969746, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 19.94209848244985, 17.178315229276553)\n",
      "client: 77_66646736\n",
      "\tarrival: 2019-08-15 18:26:36 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 22.86272443930308, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 22.058765149116518, 17.178315229276553)\n",
      "client: 141_66646736\n",
      "\tarrival: 2019-08-15 19:39:02 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 20.297714495658873, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 18.018438104788462, 17.178315229276553)\n",
      "client: 149_66646736\n",
      "\tarrival: 2019-08-15 16:54:13 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 20.479391105969746, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 19.44209848244985, 17.178315229276553)\n",
      "client: 183_66646736\n",
      "\tarrival: 2019-08-15 20:02:38 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 18.897714495658875, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 19.41843810478846, 17.178315229276553)\n",
      "client: 199_66646736\n",
      "\tarrival: 2019-08-15 19:15:49 EDT:\n",
      "\t\t('FROM:', 'FB40', 8589.16448596437, 22.081047828992208, 17.178315229276553)\n",
      "\t\t('TO:', 'FB40', 8589.16448596437, 21.23510477145513, 17.178315229276553)\n",
      "plant: F011\n",
      "\tsend: 33\n",
      "\trecv: 33\n",
      "plant: FB40\n",
      "\tsend: 35\n",
      "\trecv: 35\n",
      "plant: FB25\n",
      "\tsend: 33\n",
      "\trecv: 33\n",
      "plant: FB58\n",
      "\tsend: 7\n",
      "\trecv: 7\n",
      "plant: F011\n",
      "plant: FB25\n",
      "plant: FB40\n",
      "plant: FB58\n",
      "Date: 2019-08-16\n",
      "\n",
      "total_number_trucks = 46\n",
      "num_deliveries = 90\n",
      "6070\n",
      "6070\n",
      "6070\n",
      "6070\n",
      "2854\n",
      "min_cost_flow.Solve() = 1\n",
      "Flow cost of the min flow cost 46\n",
      "Minimum cost: -3007483862\n",
      "\n",
      "  Arc    Flow / Capacity  Cost\n",
      "total_distance: 1449358.1473307402\n",
      "total_duration: 200827.4721391201\n",
      "total_duration_est: 173922.838541418\n",
      "total_distance_client: 0\n",
      "total_duration_client: 0\n",
      "total_duration_est_client: 0\n",
      "number_client_exists: 90\n",
      "plant: F011\n",
      "\tsend: 30\n",
      "\trecv: 30\n",
      "plant: FB40\n",
      "\tsend: 28\n",
      "\trecv: 28\n",
      "plant: FB25\n",
      "\tsend: 18\n",
      "\trecv: 18\n",
      "plant: FB58\n",
      "\tsend: 14\n",
      "\trecv: 14\n",
      "plant: F011\n",
      "plant: FB25\n",
      "plant: FB40\n",
      "plant: FB58\n"
     ]
    }
   ],
   "source": [
    "plant_stats_map = {}\n",
    "g_map = {}\n",
    "for date_v, info in info_map.items():\n",
    "    print(\"Date: {}\".format(date_v))\n",
    "    print()\n",
    "    g = create_optimization_graph(info, time_interval=300)\n",
    "    g_map[date_v] = g\n",
    "    G = g.getG()\n",
    "    \n",
    "    total_number_trucks = 0\n",
    "    num_deliveries = len(info_map[date_v][\"deliveries\"].keys())\n",
    "    for k,v in info_map[date_v][\"plants\"].items():\n",
    "        total_number_trucks += int(v[\"truck_capacity\"])\n",
    "    print(\"total_number_trucks = {}\".format(total_number_trucks))\n",
    "    print(\"num_deliveries = {}\".format(num_deliveries))\n",
    "    \n",
    "    plant_df = main(g, total_number_trucks=total_number_trucks)\n",
    "    plant_stats_map[date_v] = plant_df"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.7.3"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
